Panda3D

Functions
nodePath.cxx File Reference

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University. More...

`#include "nodePath.h"`
`#include "nodePathCollection.h"`
`#include "findApproxPath.h"`
`#include "findApproxLevelEntry.h"`
`#include "internalNameCollection.h"`
`#include "config_pgraph.h"`
`#include "colorAttrib.h"`
`#include "colorScaleAttrib.h"`
`#include "cullBinAttrib.h"`
`#include "textureAttrib.h"`
`#include "texMatrixAttrib.h"`
`#include "texGenAttrib.h"`
`#include "materialAttrib.h"`
`#include "materialCollection.h"`
`#include "lightAttrib.h"`
`#include "clipPlaneAttrib.h"`
`#include "occluderEffect.h"`
`#include "polylightEffect.h"`
`#include "fogAttrib.h"`
`#include "renderModeAttrib.h"`
`#include "cullFaceAttrib.h"`
`#include "alphaTestAttrib.h"`
`#include "depthTestAttrib.h"`
`#include "depthWriteAttrib.h"`
`#include "depthOffsetAttrib.h"`
`#include "shaderAttrib.h"`
`#include "billboardEffect.h"`
`#include "compassEffect.h"`
`#include "showBoundsEffect.h"`
`#include "transparencyAttrib.h"`
`#include "antialiasAttrib.h"`
`#include "audioVolumeAttrib.h"`
`#include "texProjectorEffect.h"`
`#include "scissorEffect.h"`
`#include "texturePool.h"`
`#include "planeNode.h"`
`#include "occluderNode.h"`
`#include "lensNode.h"`
`#include "materialPool.h"`
`#include "look_at.h"`
`#include "plist.h"`
`#include "boundingSphere.h"`
`#include "geomNode.h"`
`#include "sceneGraphReducer.h"`
`#include "textureCollection.h"`
`#include "textureStageCollection.h"`
`#include "globPattern.h"`
`#include "shader.h"`
`#include "shaderInput.h"`
`#include "config_gobj.h"`
`#include "bamFile.h"`
`#include "preparedGraphicsObjects.h"`
`#include "dcast.h"`
`#include "pStatCollector.h"`
`#include "pStatTimer.h"`
`#include "modelNode.h"`
`#include "bam.h"`
`#include "bamWriter.h"`
`#include "datagramBuffer.h"`
`#include "weakNodePath.h"`

Go to the source code of this file.

## Functions
| CPT (RenderState) NodePath
| Returns the state changes that must be made to transition to the render state of this node from the render state of the other node. More...
| CPT (TransformState) NodePath
| Returns the relative transform to this node from the other node; i.e. More...
| PT (BoundingVolume) NodePath
| Returns a newly-allocated bounding volume containing the bottom node and all of its descendants. More...
| PT (Material) NodePath
| Returns the material that has been set on this particular node, or NULL if no material has been set. More...

## Detailed Description

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University.

All rights reserved.

All use of this software is subject to the terms of the revised BSD license. You should have received a copy of this license along with this source code in a file named "LICENSE."

Author
  drose

Date
  2002-02-25

Definition in file nodePath.cxx.

## Function Documentation

## ◆ CPT() [1/2]

CPT | ( | RenderState |  | ) |

Returns the state changes that must be made to transition to the render state of this node from the render state of the other node.

Recursively determines the net state changes to the indicated component node from the root of the graph.

Sets the state object on this node, relative to the other node. This computes a new state object that will have the indicated value when seen from the other node.

Recursively determines the net state changes to the indicated component node from the nth node above it. If n exceeds the length of the path, this returns the net transform from the root of the graph.

Recursively determines the net transform to the indicated component node from the root of the graph.

Recursively determines the net transform to the indicated component node from the nth node above it. If n exceeds the length of the path, this returns the net transform from the root of the graph.

If any node in the path had a net_transform effect applied, returns NULL– in this case the partial transform cannot be easily determined.

Recursively determines the net "previous" transform to the indicated component node from the root of the graph.

Recursively determines the net "previous" transform to the indicated component node from the nth node above it. If n exceeds the length of the path, this returns the net previous transform from the root of the graph.

Finds up to max_matches matches against the given path string from this node and deeper. The max_matches count indicates the maximum number of matches to return, or -1 not to limit the number returned.

Finds up to max_matches matches against the given approx_path from this node and deeper. The max_matches count indicates the maximum number of matches to return, or -1 not to limit the number returned.

The fundamental implementation of find_matches(), given a starting level (a linked list of FindApproxLevelEntry objects).

The recursive implementation of clear_model_nodes(). This walks through the subgraph defined by the indicated node and below.

Definition at line 730 of file nodePath.cxx.

## ◆ CPT() [2/2]

CPT | ( | TransformState |  | ) |

Returns the relative transform to this node from the other node; i.e.

Returns the texture matrix on the current node for the given stage, relative to the other node.

Returns the texture matrix on the current node for the given stage, or identity transform if there is no explicit transform set for the given stage.

Returns the relative "previous" transform to this node from the other node; i.e.

the transformation of this node as seen from the other node.

Sets the transform object on this node, relative to the other node. This computes a new transform object that will have the indicated value when seen from the other node.

the position of this node in the previous frame, as seen by the other node in the previous frame.

Sets the "previous" transform object on this node, relative to the other node. This computes a new transform object that will have the indicated value when seen from the other node.

Sets the texture matrix on the current node to the indicated transform for the given stage.

Enables automatic texture coordinate generation for the indicated texture stage.

Definition at line 802 of file nodePath.cxx.

## ◆ PT() [1/2]

PT | ( | BoundingVolume |  | ) |

Returns a newly-allocated bounding volume containing the bottom node and all of its descendants.

This is the bounding volume on the bottom arc, converted to the local coordinate space of the node.

Forces the recomputing of all the bounding volumes at every node in the subgraph beginning at this node and below.

This should not normally need to be called, since the bounding volumes are supposed to be recomputed automatically when necessary. It may be useful when debugging, to verify that the bounding volumes have not become inadvertently stale; it may also be useful to force animated characters to update their bounding volumes (which does not presently happen automatically).

Definition at line 5459 of file nodePath.cxx.

## ◆ PT() [2/2]

PT | ( | Material |  | ) |

Returns the material that has been set on this particular node, or NULL if no material has been set.

This is not necessarily the material that will be applied to the geometry at or below this level, as another material at a higher or lower level may override.

See also find_material().

Recursively searches the scene graph for references to the given material, and replaces them with the new material.

Since
  1.10.0

Definition at line 4231 of file nodePath.cxx.